corporate/urls.py
from django.conf.urls import patterns, include, url
from django.contrib import admin


urlpatterns = patterns('',
	url(r'^admin/doc/', include('django.contrib.admindocs.urls')),
	url(r'^admin/', include(admin.site.urls)),
	url(r'docs/', include('docs.urls')),
	url(r'', include('website.urls')),
)

docs/urls.py
from django.conf.urls import patterns, url
from docs import views

urlpatterns = patterns('',
	url(r'(?P<page>(\w|/|-)*)\.md$', views.redirect_md),
	url(r'corporations/(?P<corporation_slug>(\w|/|-)*)$', views.corporation),
	url(r'(?P<page>(\w|/|-)*)$', views.index),
)

website/urls.py
from django.conf.urls import patterns, url
from website.views import index, data, orders

# Index views
urlpatterns = patterns('',
	url(r'^$', index.index),
	url(r'^join_game$', index.join_game),
	url(r'^create_game$', index.create_game),
	url(r'^login$', 'django.contrib.auth.views.login'),
	url(r'^logout$', 'django.contrib.auth.views.logout_then_login'),
	url(r'^signup$', index.signup),
)

# Data views
urlpatterns += patterns('',
	url(r'^game/(?P<game_id>[0-9]+)/add_player$', data.add_player),
	url(r'^game/(?P<game_id>[0-9]+)/game_panel$', data.game_panel),
	url(r'^game/(?P<game_id>[0-9]+)/wallstreet$', data.wallstreet),
	url(r'^game/(?P<game_id>[0-9]+)/wallstreet/(?P<turn>[0-9]+)$', data.wallstreet),
	url(r'^game/(?P<game_id>[0-9]+)/corporations$', data.corporation),
	url(r'^game/(?P<game_id>[0-9]+)/corporations/(?P<corporation_slug>[a-z0-9-]+)$', data.corporation),
	url(r'^game/(?P<game_id>[0-9]+)/corporations/(?P<corporation_slug>[a-z0-9-]+)/(?P<turn>[0-9]+)$', data.corporation),
	url(r'^game/(?P<game_id>[0-9]+)/discussion/(?P<sender_id>[0-9]+)$', data.discussion),
	url(r'^game/(?P<game_id>[0-9]+)/player/(?P<player_id>[0-9]+)$', data.player),
	url(r'^game/(?P<game_id>[0-9]+)/player/(?P<player_id>[0-9]+)/(?P<turn>[0-9]+)$', data.player),
	url(r'^game/(?P<game_id>[0-9]+)/shares$', data.shares),
	url(r'^game/(?P<game_id>[0-9]+)/shares/(?P<turn>[0-9]+)$', data.shares),
)

# Orders views
urlpatterns += patterns('',
	url(r'^game/(?P<game_id>[0-9]+)/orders$', orders.orders),
	url(r'^game/(?P<game_id>[0-9]+)/orders/new/(?P<order_type>\w+)$', orders.add_order),
	url(r'^game/(?P<game_id>[0-9]+)/orders/delete/(?P<order_id>\w+)$', orders.delete_order),
	url(r'^game/(?P<game_id>[0-9]+)/orders/get_targets/(?P<stealer_corporation_id>[0-9]+)$', orders.get_targets),
)

player_messages/models.py
# -*- coding: utf-8 -*-
from django.db import models
from django.db.models import Q
from django.forms import ModelForm, Textarea


class MessageManager(models.Manager):
	def get_discussion(self, receiver, sender):
		"""
		return all the messages and update read messages status
		"""
		messages = Message.objects.filter(Q(receiver=receiver, sender=sender) | Q(receiver=sender, sender=receiver)).order_by('creation')
		for message in messages:
			if message.receiver == receiver and message.read is False:
				message.read = True
				message.save()
		return messages


class Message(models.Model):
	"""
	Messages from a player to an other player
	"""
	objects = MessageManager()

	sender = models.ForeignKey('engine.Player', related_name='sender')
	receiver = models.ForeignKey('engine.Player', related_name='receiver')
	content = models.CharField(max_length=300)
	read = models.BooleanField(default=False)
	creation = models.DateTimeField(auto_now_add=True)


class MessageForm(ModelForm):
	class Meta:
		model = Message
		fields = ['content']
		widgets = {
			'content': Textarea(attrs={'cols': 35, 'rows': 4}),
		}

	def __init__(self, *args, **kwargs):
		super(MessageForm, self).__init__(*args, **kwargs)
		self.fields['content'].label = ""

website/models.py
from django.db import models
from django.contrib.auth.models import AbstractUser
from django.contrib.auth.models import UserManager


class User(AbstractUser):
	objects = UserManager()

	phone = models.CharField(max_length=15, null=True, blank=True)
	skype = models.CharField(max_length=50, null=True, blank=True)

website/views/data.py
# -*- coding: utf-8 -*-
from __future__ import absolute_import
from django.shortcuts import render as django_render, redirect
from django.contrib.auth.decorators import login_required
from django.utils.safestring import mark_safe
from django.db.models import Count, Case, When, IntegerField
from django.http import Http404, HttpResponseRedirect

from utils.read_markdown import parse_markdown
from engine.models import Player, PlayerForm, Game
from engine_modules.corporation.models import Corporation
from engine_modules.player_points.models import PlayerPoints
from engine_modules.share.models import Share
from player_messages.models import Message, MessageForm
from website.utils import get_shares_count, is_top_shareholder, is_citizen, get_current_money
from website.decorators import render, find_player_from_game_id, inject_game_and_player_into_response, turn_by_turn_view
from logs.models import Log, ConcernedPlayer

import json


@login_required
@render('game/add_player.html')
def add_player(request, game_id):
	"""
	Join the game by adding a player
	"""
	# if gameid is not null, we display the menu.
	# We dont want to display the menu for creation but we want to display it for modification.
	game = Game.objects.get(pk=game_id)

	# If playeryer exists we will change it, else it's a creation
	try:
		player = Player.objects.select_related('game').get(user=request.user, game=game_id)
	except:
		player = None

	if request.method == 'POST':
		form = PlayerForm(request.POST, request.FILES, instance=player, game=game)
		if form.is_valid():
			# We add the user and the game (they are not in the form)
			player = form.save(commit=False)
			player.user = request.user
			player.game = game
			player.save()
			form.save_m2m()
			return redirect('website.views.data.wallstreet', game_id=game_id)
	else:
		if player is None:
			# creation form
			form = PlayerForm(game=game)
			# We disable the game to hide the menu on this screen
			game = None
		else:
			# display game menu
			game = player.game
			# edit form
			form = PlayerForm(instance=player, game=game)

	return django_render(request, 'game/add_player.html', {
		"game_id": game_id,
		"form": form,
		"game": game,
		"request": request,
		"player": player
	})


@login_required
@render('game/wallstreet.html')
@find_player_from_game_id
@inject_game_and_player_into_response
@turn_by_turn_view
def wallstreet(request, game, player, turn):
	"""
	Wallstreet data
	"""
	# Set the game_id in session to always display all tabs
	request.session['gameid'] = game.pk

	ranking = []
	# Table data
	corporations = game.get_ladder(turn=turn - 1)
	for corporation in corporations:
		corporation_markets = corporation.get_corporation_markets(turn - 1).order_by('market__name').select_related('market')
		events = Log.objects.for_corporation(corporation, player, turn)
		if turn == game.current_turn:
			assets = corporation.assets
		else:
			assets = 0
			for market in corporation_markets:
				assets += market.value + market.bubble_value
		delta = 0
		for event_delta in Log.objects.for_delta(corporation, turn):
			delta += event_delta.delta

		events = Log.objects.for_corporation(corporation, player, turn).exclude(delta=0)
		ranking.append({"corporation": corporation, "assets": assets, "delta": delta, "corporation_market": corporation_markets, "events": events})

	return {
		"ranking": ranking,
		"pods": ['turn_spinner', 'd_inc', 'current_player', 'players', ],
		"turn": turn,
		"corporations": corporations,
		"request": request,
	}


@login_required
@render('game/game_panel.html')
@find_player_from_game_id
@inject_game_and_player_into_response
@turn_by_turn_view
def game_panel(request, game, player, turn):
	"""
	Game panel to resolve turn and start the game
	"""

	# If you are not the owner, you have nothing to do here
	# if game.owner != request.user:
	# raise Http404("Only the owner of a game can manage the game")

	# Set the game_id in session to always display all tabs
	request.session['gameid'] = game.pk

	if game.ended:
		ranking = PlayerPoints.objects.filter(player__game=game, turn=turn).order_by('-total_points')
		for pp in ranking:
			if pp.total_points == ranking[0].total_points:
				pp.win = True
			else:
				pp.win = False
		players = game.player_set.all()
	else:
		ranking = None
		players = game.player_set.all().annotate(
				numordre=Count(Case(
					When(order__turn=game.current_turn, then=1),
					delfault=0,
					output_field=IntegerField(),
				))
			).filter(numordre=0)

		if(request.GET.get('resolve_turn') and player.user == game.owner):
			game.resolve_current_turn()

		if(request.GET.get('start_game') and player.user == game.owner):
			game.start_game()

		if(request.GET.get('end_game') and player.user == game.owner):
			game.end_game()

	return django_render(request, 'game/game_panel.html', {
		"game": game,
		"request": request,
		"players": players,
		"pods": ['d_inc', 'current_player', 'players', ],
		"turn": game.current_turn,
		"player": player,
		"ranking": ranking,
	})


@login_required
@render('game/discussion.html')
@find_player_from_game_id
@inject_game_and_player_into_response
def discussion(request, game, player, sender_id):
	"""
	Panel to show discussions with other players
	"""
	# Set the game_id in session to always display all tabs
	request.session['gameid'] = game.pk

	sender = Player.objects.get(pk=sender_id)

	if request.method == 'POST':
		if player.game != sender.game:
			raise Http404("Seul les joueurs appartenant à la même partie peuvent discuter entre eux")
		form = MessageForm(request.POST)
		if form.is_valid():
			# We add the sender and the receiver (they are not in the form)
			message = form.save(commit=False)
			message.sender = player
			message.receiver = sender
			message.save()
			return HttpResponseRedirect('')
	else:
		# creation form
		form = MessageForm()

	messages = Message.objects.get_discussion(player, sender)

	return django_render(request, 'game/discussion.html', {
		"game": game,
		"sender": sender,
		"messages": messages,
		"form": form,
		"request": request,
	})


@login_required
@render('game/corporation.html')
@find_player_from_game_id
@inject_game_and_player_into_response
@turn_by_turn_view
def corporation(request, player, game, corporation_slug, turn):
	"""
	Corporation data
	"""
	# Set the game_id in session to always display all tabs
	request.session['gameid'] = game.pk

	corporation = Corporation.objects.get(base_corporation_slug=corporation_slug, game_id=game.pk)
	share_holders = game.player_set.filter(game_id=game.pk, share__corporation=corporation).annotate(qty_share=Count('share')).order_by('-qty_share')
	previous_corporation_markets = corporation.get_corporation_markets(turn=turn - 1)
	current_markets = corporation.markets
	competitors = game.corporation_set.filter(corporationmarket__market__in=current_markets).distinct().order_by('base_corporation_slug')

	summary = []
	for corpo in competitors:
		assets = []
		holders = game.player_set.filter(share__corporation__base_corporation_slug=corpo.base_corporation_slug).distinct()
		corporation_markets = corpo.corporationmarket_set.filter(market__in=current_markets, turn=turn - 1)
		for market in current_markets:
			assets.append(next((cm.value for cm in corporation_markets if cm.market.name == market.name), None))

		summary.append({
			"corporation": corpo,
			"assets": assets,
			"holders": holders
		})

	assets_history = corporation.assethistory_set.all()

	for corporation_market in previous_corporation_markets:
		corporation_market.events = Log.objects.for_corporation_market(corporation_market, player)

	logs = Log.objects.for_corporation(corporation, asking_player=player, turn=turn).filter(delta=0)

	return {
		"corporation": corporation,
		"share_holders": share_holders,
		"assets_history": assets_history,
		"markets": current_markets,
		"corporation_markets": previous_corporation_markets,
		"summary": summary,
		# Turn_spinner doesn't work, because the URL with e turn isn't allowed, which makes sense, because for this description, the turn doesn't matter
		"pods": ['d_inc', 'current_player', 'players', ],
		"turn": game.current_turn,
		"logs": logs,
		"request": request,
	}


@login_required
@render('game/shares.html')
@find_player_from_game_id
@inject_game_and_player_into_response
@turn_by_turn_view
def shares(request, game, player, turn):
	"""
	Shares data
	"""
	# Set the game_id in session to always display all tabs
	request.session['gameid'] = game.pk

	players = game.player_set.all().order_by('name')
	corporations = list(game.get_ladder(turn=turn - 1))
	shares = Share.objects.filter(player__game=game, turn__lte=turn - 1).select_related('corporation', 'player')
	corporations_shares = []
	totals = []
	for player in players:
		total = 0
		for corporation in corporations:
			total += get_shares_count(corporation, player, shares)
		totals.append(total)
	for corporation in corporations:
		assets = corporation.assethistory_set.get(turn=turn - 1).assets

		corporation_shares = {
			"corporation": corporation,
			"assets": assets,
			"shares": [{"count": get_shares_count(corporation, player, shares), "top": is_top_shareholder(corporation, player, shares), "citizen": is_citizen(corporation, player)} for player in players]
		}
		corporations_shares.append(corporation_shares)
	players = game.player_set.all().annotate(Count('share')).select_related('user').order_by('name')

	return {
		"totals": totals,
		"players": players,
		"corporations": corporations,
		"corporations_shares": corporations_shares,
		"pods": ['turn_spinner', 'd_inc', 'current_player', 'players', ],
		"turn": turn,
		"request": request,
	}


@login_required
@render('game/player.html')
@find_player_from_game_id
@inject_game_and_player_into_response
@turn_by_turn_view
def player(request, player, game, player_id, turn):
	"""
	Player data
	"""

	# Set the game_id in session to always display all tabs
	request.session['gameid'] = game.pk

	player_profile = Player.objects.get(pk=player_id, game_id=game.pk)

website/views/index.py
# -*- coding: utf-8 -*-
from django.shortcuts import redirect
from django.contrib.auth import authenticate, login
from django.db import transaction
from django.shortcuts import render as django_render
from django.http import Http404

from website.forms import UserCreationForm
from website.decorators import render
from django.db.models import Count
from engine.models import Game, GameForm


@render('index.html')
def index(request):
	"""
	Welcome to the Corporate Game!
	"""
	# On récupère le game id si on l'a en session pour accéder aux onglets de la session en cours
	gameid = None
	try:
		gameid = request.session['gameid']
	except:
		pass

	players = []

	if request.user.is_authenticated():
		players = request.user.player_set.all().select_related('game')

	return {
		"is_authenticated": request.user.is_authenticated(),
		"user": request.user,
		"players": players,
		"gameid": gameid,
		"request": request,
	}


@render('join_game.html')
def join_game(request):
	"""
	Join a game
	"""
	# On récupère le game id si on l'a en session pour accéder aux onglets de la session en cours
	gameid = None
	try:
		gameid = request.session['gameid']
	except:
		pass

	games = []
	MAX_PLAYER = 8

	if request.user.is_authenticated():
		# We get every game that is not started and with a number of players < max players
		games = Game.objects.exclude(player__user=request.user).filter(status='created').annotate(num_player=Count('player')).filter(num_player__lte=MAX_PLAYER)

	return {
		"is_authenticated": request.user.is_authenticated(),
		"user": request.user,
		"games": games,
		"gameid": gameid,
		"request": request,
	}


@render('create_game.html')
def create_game(request):
	"""
	Create a game
	"""
	if not request.user.is_authenticated():
		raise Http404("You need to be logged in to create a game")

	if request.method == 'POST':
		form = GameForm(request.POST)
		if form.is_valid():
			# We add the user and the game (they are not in the form)
			game = form.save(commit=False)
			game.owner = request.user
			game.save()
			return redirect('website.views.data.add_player', game_id=game.pk)
	else:
		# creation form
		form = GameForm()

	return django_render(request, 'create_game.html', {
		"form": form,
		"request": request,
	})


@render('signup.html')
@transaction.atomic
def signup(request):
	"""
	Signup page, for new users.
	"""

	if request.user.is_authenticated():
		return redirect('website.views.index.index')

	if request.POST:
		form = UserCreationForm(request.POST)
		if form.is_valid():
			user = form.save()
			user = authenticate(username=request.POST.get('username'), password=request.POST.get('password1'))
			login(request, user)

			return redirect('website.views.index.index')
	else:
		form = UserCreationForm()

	return {
		"form": form
	}

website/templates/create_game.html
{% extends "template.html" %}

{% block content %}
<p>Vous pouvez ne pas mettre de mot de passe sur la partie pour qu'elle soit ouverte à tous</p>
<div>
<form method="post" action="{% url "website.views.index.create_game" %}">
	<table>
	{{ form.as_table }}
	<tr class="submit-order">
		<td colspan="2">
			<div class="button-content">
				<div class="cornered-top"></div>
				<input type="submit" value="Créer la partie" />
				<div class="cornered-bottom"></div>
			</div>
		</td>
	</tr>
	</table>
</form>
</div>
{% endblock content %}

website/templates/index.html
{% extends "template.html" %}

{% block content %}
<p>Depuis votre penthouse cinq étoiles, planifiez froidement votre ascension en contemplant les trottoirs sur lesquels celles de beaucoup avant vous ont connue une fin brutale.</p>

<p>Le <strong>Corporate Game: Manhattan</strong> est un jeu par navigateur en tour par tour (un tour par jour, sept tours par partie).<br />
Rejoignez la danse pour devenir le roi d'un instant !</p>

{% if players %}
<hr />
<p>Vos parties en cours :</p>
<ul>
{% for player in players %}
	<li><a href="{% url "website.views.data.wallstreet" game_id=player.game_id %}">{{ player.name}}, {{ player.game.city }}</a></li>
{% endfor %}
</ul>
{% endif %}

{% if is_authenticated %}
<hr />
<small><a href="{% url 'website.views.index.join_game' %}">Rejoindre une partie</a></small>.
<hr />
<small><a href="{% url 'django.contrib.auth.views.logout_then_login' %}">Déconnexion</a></small>.
{% else %}
<hr />
<small><a href="{% url 'django.contrib.auth.views.login' %}">Connexion</a></small>.
{% endif %}
{% endblock content %}

website/templates/join_game.html
{% extends "template.html" %}

{% block content %}
{% if games %}
<p>Cliquez sur une partie pour la rejoindre :</p>
<hr />
<ul>
{% for game in games %}
	<li><a href="{% url "website.views.data.add_player" game_id=game.pk %}">{{ game.city }} ({{ game.num_player }} joueurs) {% if game.password %}[Mot de passe requis]{% endif %}</a></li>
	
{% endfor %}
</ul>
{% else %}
<p>Aucune partie disponible</p>
{% endif %}
<hr />
<a href="{% url "website.views.index.create_game" %}">Créer une partie</a>

{% endblock content %}

website/templates/signup.html
{% extends "template.html" %}

{% block title %}Inscription{% endblock %}
{% block h1 %}Inscription{% endblock %}

{% block content %}

<form method="post" action="{% url "website.views.index.signup" %}">
	<table>
	{{ form.as_table }}
	<tr>
		<td colspan="2">
			<input type="submit" value="Inscription" />
		</td>
	</tr>
	</table>
</form>

{% endblock content %}

website/templates/template.html
{% load staticfiles %}
{% load compress %}
{% load display_pod %}
{% load make_link_active %}

<!DOCTYPE html>
<html lang="en">
<head>
	<meta name="viewport" content="width=device-width, initial-scale=1.0">
	{% compress css %}
	<link rel="stylesheet" type="text/less" media="all" href="{% static 'style.less' %}" />
	<link rel="stylesheet" type="text/css" media="all" href="{% static 'vendor/tipped.css' %}" />
	<link rel="stylesheet" type="text/less" media="all" href="{% static 'style.less' %}" />
	{% endcompress %}
	<link rel="icon" href="{% block favicon %}{{ STATIC_URL }}favicon.gif{% endblock %}" type="image/x-icon" />

	{% block head %}{% endblock %}
	<title>{% block title %}Corporate game{% endblock %}</title>
	<link href='//fonts.googleapis.com/css?family=Roboto:400,300,700|Oswald:400,700,300' rel='stylesheet' type='text/css'>
</head>

<body class="{% block body %}corporate{% endblock %}">
<h1 class="main-logo"><a href="/">Corporate Game</a></h1>
<div class="grid-container main-container">
{% comment %}
	<div id="wrapper">
		<div id="sidebar">
			<ul class="general">
				<li><a href="{% url 'website.views.index.index' %}">accueil</a></li>
				<li><a href="{% url 'docs.views.index' page='' %}">docs</a></li>
			{% if not user.is_authenticated %}
				<li><a href="{% url 'django.contrib.auth.views.login' %}">login</a></li>
				<li><a href="{% url 'website.views.index.signup' %}">inscription</a></li>
			{% endif %}
			</ul>

			{% if user.is_authenticated %}
			{% if game %}
			<ul class="game">
				<li><a href="{% url 'website.views.orders.orders' game_id=game.pk %}">ordres</a></li>
			</ul>

			<ul class="data">
				<li><a href="{% url 'website.views.data.wallstreet' game_id=game.pk %}">wall street</a></li>
				<li><a href="{% url 'website.views.data.players' game_id=game.pk %}">joueurs</a></li>
				<li><a href="{% url 'website.views.data.shares' game_id=game.pk %}">parts</a></li>
			</ul>
			{% else %}
			<ul class="game">
				{% for player in user.player_set.all %}
				<li><a href="{% url 'website.views.data.wallstreet' game_id=player.game_id %}">{{ player.game.city }}</a></li>
				{% endfor %}
			</ul>
			{% endif %}
			{% endif %}
		</div>
{% endcomment %}
	<section class="content-container">
		<ul class="menu">
		<li><a href="{% url 'website.views.index.index' %}">Accueil</a></li>
		{% if game.id != None %}
			<li><a class={% make_link_active "orders" %} href="{% url 'website.views.orders.orders' game_id=game.id %}">Ordres</a></li>
			<li><a class={% make_link_active "wallstreet" %} href="{% url 'website.views.data.wallstreet' game_id=game.id %}">Wallstreet</a></li>
			<li><a class={% make_link_active "shares" %} href="{% url 'website.views.data.shares' game_id=game.id %}">Parts</a></li>
			<li><a class={% make_link_active "game_panel" %} href="{% url 'website.views.data.game_panel' game_id=game.id %}">Partie</a></li>
		{% elif gameid != None %}
			<li><a class={% make_link_active "orders" %} href="{% url 'website.views.orders.orders' game_id=gameid %}">Ordres</a></li>
			<li><a class={% make_link_active "wallstreet" %} href="{% url 'website.views.data.wallstreet' game_id=gameid %}">Wallstreet</a></li>
			<li><a class={% make_link_active "shares" %} href="{% url 'website.views.data.shares' game_id=gameid %}">Parts</a></li>
		{% endif %}
			<li class="rules"><a title="Les règles du jeu" class="tooltip" href="{% url 'docs.views.index' page='' %}"><svg role="img" class="svg-rules svg--medium svg--white"><use xlink:href="/static/img/sprite.svg#rules"></use></svg><span class="visually-hidden">Les règles du jeu</span></a></li>
		</ul>

		<article class="content">
			<h1 class="main-h1-title">{% block h1 %}{% endblock %}</h1>

			{% block content %}{% endblock %}
		</article>
	</section>

	<aside class="sidebar" role="sidebar">
		<div class="content-sidebar">
		<div class="current-player">
			<div class="player">
				<span class="player-avatar">
					{% if player %}
						<img title="Avatar de {{ player.name }}" src="{{ player.avatar.thumbnail.url }}" class="tooltip"/>
					{% endif %}
				</span>
				<span class="player-name">
				{% if player %}
					<a href="{% url 'website.views.data.add_player' game_id=player.game_id %}" title="Modifier votre personnage">{{ player.name }}</a>
				{% elif is_authenticated %}
					<a href="{% url 'website.views.index.index' %}">Sélectionnez une partie&hellip;</a>
				{% else %}
					<a href="{% url 'django.contrib.auth.views.login' %}">Connexion</a>
				{% endif %}
				</span>
			</div>
			<span class="icon-logout icon-medium">
			</span>
		</div>

		{% for pod in pods %}
			{% display_pod pod %}
		{% endfor %}

	</aside>
</div>

<script type="text/javascript" src="{% static 'vendor/jquery-2.1.4.min.js' %}"></script>
<script type="text/javascript" src="{% static 'vendor/tipped.js' %}"></script>
<script type="text/javascript">
$( document ).ready(function() {
    $( ".corporation-row" ).each(function( index ) {
      
      var $that = $(this);

	  if (index === 0) { 
        var heightEven = $that.height() * 2 / 3;
        $that.next().css( "margin-top", heightEven );
      }
      else if (index % 2 === 0) { 
        var heightEven = $that.height() / 3;
        $that.next().css( "margin-top", heightEven );
      }
      else { 
	    var heightOdd = $that.height() / 3 * ( - 1 );
	    $that.next().css( "margin-top", heightOdd );
      }
    });


    $('.dropdown').on('click', 'ul > li > ul > li > ul > li', function () {
    	var text = $(this).text()
    	$('.dropdown > ul > li span').text(text);
    });
});
</script>
<script type='text/javascript'>
$(function() {
  Tipped.create('svg, .tooltip');
});
</script>
<script type="text/javascript">
	$(document).ready(function() {
		window.onload = function() {
		$("#id_content").focus();
		$("#chatbox").prop({ scrollTop: $("#chatbox").prop("scrollHeight") });
		//  setting focus to a textbox which added to template page direcltly using html tag the focus() method works well
		};
	});
</script>
</body>
</html>